## pure-stllib-0.6.tar.gz

=== Makefile ===
# Makfile for stllib

pkgname = stllib

version = 0.6

.PHONY: all stlvec stlmap dist check install uninstall clean dist distcheck

# platform-specific setup

DLL         = $(shell pkg-config pure --variable DLL)
PIC         = $(shell pkg-config pure --variable PIC)
shared      = $(shell pkg-config pure --variable shared)
libdir      = $(shell pkg-config pure --variable libdir)
installdir  = $(addprefix $(DESTDIR), $(libdir)/pure)

MOD_CXXFLAGS = $(PIC) $(shell pkg-config pure --cflags) $(CFLAGS) $(CPPFLAGS)
MOD_LDFLAGS = $(shell pkg-config pure --libs) $(LDFLAGS)

CFLAGS = -g -O2 -Wall -Wextra

ifeq "$(DLL)" ".dylib"
DLL_FLAGS = -install_name "$(libdir)/pure/$@"
endif

# Basic rules to build the module, clean, check, install and uninstall.

cppsource = stlbase.cpp
puresource = $(patsubst %.cpp, %.pure, $(cppsource))
object = $(patsubst %.cpp, %$(DLL), $(cppsource))

all: $(object) stlmap stlvec

$(object): $(cppsource)
	$(CXX) $(shared) $(DLL_FLAGS) -o $@ $(MOD_CXXFLAGS) $(cppsource) \
	$(MOD_LDFLAGS) $(LIBS) -lgmp

stlvec: $(object)
	$(MAKE) --directory=pure-stlvec

stlmap: $(object)
	$(MAKE) --directory=pure-stlmap

clean:
	rm -Rf *.o *$(DLL)*
	rm -fr BUILD
	$(MAKE) clean --directory=pure-stlvec
	$(MAKE) clean --directory=pure-stlmap

install:
	test -d $(installdir) || mkdir -p $(installdir)
	cp $(puresource) $(object) $(installdir)
	$(MAKE) install DESTDIR=$(DESTDIR) --directory=pure-stlvec
	$(MAKE) install DESTDIR=$(DESTDIR) --directory=pure-stlmap 

uninstall:
	rm -f $(addprefix $(installdir)/, $(puresource) $(object))
	$(MAKE) uninstall --directory=pure-stlvec
	$(MAKE) uninstall --directory=pure-stlmap

check:
	rm -rf BUILD
	$(MAKE) install DESTDIR=$(shell pwd)/BUILD
	./check_script $(shell pwd)/BUILD

# Roll a distribution tarball.

distfiles = Makefile README COPYING check_script *.pure *.hpp *.cpp doc/*.pdf debian/*
sedfiles = README
dist = pure-$(pkgname)-$(version)
date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" \
	        -e "s?|today|?$(date)?g" < $(1) > $(2)
dist:
	rm -rf $(dist)
	mkdir $(dist)
	mkdir $(dist)/doc
	mkdir $(dist)/debian
	for x in $(distfiles); do ln -sf $$PWD/$$x $(dist)/$$x; done
	for x in $(sedfiles); do rm -f $(dist)/$$x; \
                              $(call datesubst,$$PWD/$$x,$(dist)/$$x); done
	$(MAKE) dist DIST=../$(dist) --directory=pure-stlvec
	$(MAKE) dist DIST=../$(dist) --directory=pure-stlmap
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && $(MAKE) && $(MAKE) check
	rm -rf $(dist)

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://bitbucket.org/purelang/pure-lang/downloads/$(dist).tar.gz -O $@

=== pure-stlmap/Makefile ===

pkgname = pure-stlmap
version = 0.4

# platform-specific setup

DLL         = $(shell pkg-config pure --variable DLL)
PIC         = $(shell pkg-config pure --variable PIC)
shared      = $(shell pkg-config pure --variable shared)
libdir      = $(shell pkg-config pure --variable libdir)
installdir  = $(addprefix $(DESTDIR), $(libdir)/pure)

MOD_CXXFLAGS = $(PIC) $(shell pkg-config pure --cflags) -I.. \
	       $(CFLAGS) $(CPPFLAGS)
MOD_LDFLAGS = $(shell pkg-config pure --libs) $(LDFLAGS)

CFLAGS = -g -O2 -Wall -Wextra
ifneq "$(DLL)" ".so"
# additional libraries to be linked (Mac/Windows only)
EXTRA_LIBS = ../stlbase$(DLL)
endif
ifeq "$(DLL)" ".dylib"
DLL_FLAGS = -install_name "$(libdir)/pure/$@"
endif

# Basic rules to build the modules, clean, install and uninstall.

cppsource = stlmap.cpp stlmmap.cpp stlhmap.cpp
puresource = $(patsubst %.cpp, %.pure, $(cppsource))
objects = $(patsubst %.cpp, %$(DLL), $(cppsource))

all: $(objects)

%$(DLL) : %.cpp
	$(CXX) $(shared) $(DLL_FLAGS) -std=c++0x $< -o $@ $(MOD_CXXFLAGS) \
	$(MOD_LDFLAGS) $(EXTRA_LIBS) $(LIBS)

clean:
	rm -Rf *.o *$(DLL)*

install: $(puresource) $(objects)
	test -d $(installdir) || mkdir -p $(installdir)
	cp $^ $(installdir)

uninstall:
	rm -f $(addprefix $(installdir)/, $(puresource) $(objects))

check:
	cd uts; pure -I$(installdir) -L$(installdir) -x check_uts.pure uts_*

# Make distribution files in $(DIST)/$(pkgname)

distfiles = README Makefile *.hpp *.cpp *.pure uts/* examples/*
sedfiles = README
dist = $(DIST)/$(pkgname)
date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" \
                -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	mkdir -p $(dist)/uts
	mkdir -p $(dist)/examples
	for x in $(distfiles); do ln -sf $$PWD/$$x $(dist)/$$x; done
	for x in $(sedfiles); do rm -f $(dist)/$$x; \
                 $(call datesubst,$$PWD/$$x,$(dist)/$$x); done

=== pure-stlvec/Makefile ===

pkgname = pure-stlvec
version = 0.4

# platform-specific setup

DLL         = $(shell pkg-config pure --variable DLL)
PIC         = $(shell pkg-config pure --variable PIC)
shared      = $(shell pkg-config pure --variable shared)
libdir      = $(shell pkg-config pure --variable libdir)
installdir  = $(addprefix $(DESTDIR), $(libdir)/pure)


MOD_CXXFLAGS = $(PIC) $(shell pkg-config pure --cflags) -I.. \
	       $(CFLAGS) $(CPPFLAGS)
MOD_LDFLAGS = $(shell pkg-config pure --libs) $(LDFLAGS)

CFLAGS = -g -O2 -Wall -Wextra
ifneq "$(DLL)" ".so"
# additional libraries to be linked (Mac/Windows only)
EXTRA_LIBS = ../stlbase$(DLL)
STLVECLIB = stlvec$(DLL)
endif
ifeq "$(DLL)" ".dylib"
DLL_FLAGS = -install_name "$(libdir)/pure/$@"
endif

# Basic rules to build the module, clean, install and uninstall.

puresource = stlvec.pure
algo_basenames = sv_modifying sv_nonmodifying sv_sort \
	         sv_merge sv_heap sv_minmax sv_numeric
algo_source = $(addsuffix .cpp, $(algo_basenames))
objects = stlvec$(DLL) stlalgorithm$(DLL)

all: $(objects)

stlvec$(DLL): stlvec.cpp 
	$(CXX) $(shared) $(DLL_FLAGS) -o $@ $(MOD_CXXFLAGS) \
        stlvec.cpp $(MOD_LDFLAGS) $(EXTRA_LIBS) $(LIBS)

stlalgorithm$(DLL): $(algo_source) stlvec$(DLL)
	$(CXX) $(shared) -o $@ $(MOD_CXXFLAGS) \
        $(algo_source) $(MOD_LDFLAGS) $(EXTRA_LIBS) $(STLVECLIB) $(LIBS)

clean:
	rm -Rf *.o *$(DLL)*

install: $(puresource) $(objects)
	test -d $(installdir) || mkdir -p $(installdir)
	cp -r $^ stlvec $(installdir) 

uninstall:
	rm -rf $(addprefix $(installdir)/, $(puresource) $(objects) stlvec)

check:
	cd ut; pure -I$(installdir) -L$(installdir) -x ut_all.pure


# Make distribution files in $(DIST)/$(pkgname)

distfiles = README Makefile *.hpp *.cpp *.pure stlvec/* ut/* examples/*
sedfiles = README
dist = $(DIST)/$(pkgname)
date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" \
                -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	mkdir -p $(dist)/stlvec
	mkdir -p $(dist)/ut
	mkdir -p $(dist)/examples
	for x in $(distfiles); do ln -sf $$PWD/$$x $(dist)/$$x; done
	for x in $(sedfiles); do rm -f $(dist)/$$x; \
                 $(call datesubst,$$PWD/$$x,$(dist)/$$x); done

=== debian/changelog ===
pure-stllib (0.5-1) precise; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Thu, 19 Sep 2013 08:24:33 +0200

pure-stllib (0.4-1) natty; urgency=low

  * New upstream release

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 03 Dec 2012 07:29:04 +0100

pure-stllib (0.3-2) natty; urgency=low

  * Fixes for compatibility with g++ 4.4 (Lucid)

 -- Albert Graef <Dr.Graef@t-online.de>  Wed, 13 Jun 2012 05:45:36 +0200

pure-stllib (0.3-1) natty; urgency=low

  * New upstream release

 -- Albert Graef <Dr.Graef@t-online.de>  Tue, 12 Jun 2012 01:29:43 +0200

pure-stllib (0.2-2) natty; urgency=low

  * Prevent zipping of examples

 -- Albert Graef <Dr.Graef@t-online.de>  Sun, 27 May 2012 00:15:14 +0200

pure-stllib (0.2-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Wed, 23 May 2012 20:57:01 +0200

=== debian/control ===
Source: pure-stllib
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure, pure-dev, pkg-config
Standards-Version: 3.9.1
Homepage: http://purelang.bitbucket.org

Package: pure-stllib
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: another STL interface for the Pure programming language
 Pure is a modern-style functional programming language based on term
 rewriting. This package contains a pair of Pure addons, pure-stlvec and
 pure-stlmap. These addons provide Pure interfaces to a selection of
 containers provided by the C++ Standard Library, specialized to hold pointers
 to arbitrary Pure expressions. pure-stlvec is a Pure interface to C++'s
 vector and the STL algorithms that act on them. pure-stlmap is an interface
 to six (of the eight) of C++'s associative containers: map, set, multimap,
 multiset, unordered_map and unordered_set.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build -- prefix=/usr
	mkdir examples && cp -r pure-stlvec/examples examples/pure-stlvec && cp -r pure-stlmap/examples examples/pure-stlmap

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_compress:
	dh_compress -X.pure -X.txt -X.pdf

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

https://bitbucket.org/purelang/pure-lang/downloads/pure-stllib-(.*)\.tar\.gz
